VERSION 5.00
Begin {C62A69F0-16DC-11CE-9E98-00AA00574A4F} frmOutlookData 
   Caption         =   "Create Merge Letters"
   ClientHeight    =   7944
   ClientLeft      =   36
   ClientTop       =   324
   ClientWidth     =   7044
   OleObjectBlob   =   "frmOutlookData.frx":0000
   StartUpPosition =   1  'CenterOwner
End
Attribute VB_Name = "frmOutlookData"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim lst As MSForms.ListBox
   
Private Sub cmdSelectFolder_Click()
'Created by Helen Feddema 7-10-2000
'Last modified 7-10-2000

On Error GoTo ErrorHandler

   Dim appOutlook As New Outlook.Application
   Dim nms As Outlook.NameSpace
   Dim fld As Outlook.MAPIFolder
   Dim itms As Outlook.Items
   Dim strContactArray() As String
   Dim lngContactCount As Long
   Dim itm As Object
   Dim lngRow As Long
   
SelectFolder:
   Set nms = appOutlook.GetNamespace("MAPI")
   Set fld = nms.PickFolder
   
   If fld Is Nothing Then
      MsgBox "Please select a folder"
      Exit Sub
   Else
      'Test whether folder is a Contacts folder
      If fld.DefaultItemType <> olContactItem Then
         MsgBox "Please select a Contacts folder"
         GoTo SelectFolder
      End If
   End If

   Me.txtFolder.Value = fld.Name
   Me![txtLetterText].Value = "Type letter text here"
   Set itms = fld.Items
   lngContactCount = itms.Count
   itms.Sort "[LastName]", False
   Set lst = lstContacts
   
   lngContactCount = itms.Count
   If lngContactCount = 0 Then
      MsgBox "No contacts found in selected folder"
      Exit Sub
   Else
      Debug.Print lngContactCount & " unfiltered contacts"
   End If

   'Count number of contacts with basic name and address data
   lngRow = 0

   For Each itm In itms
      'Check each item in the folder and only process contact items
      If itm.Class = olContact Then
         If itm.FullName <> "" And itm.CompanyName <> "" _
            And itm.BusinessAddress <> "" Then
            lngRow = lngRow + 1
         End If
      End If
   Next
   
   'Fill Contacts listbox with data from each contact in folder
   'that has basic name and address data
   ReDim strContactArray(lngRow - 1, 3)
   lngRow = 0

   For Each itm In itms
      If itm.Class = 40 Then
         If itm.FullName <> "" And itm.CompanyName <> "" _
            And itm.BusinessAddress <> "" Then
            'Debug.Print "Adding " & itm.LastNameAndFirstName & " to array"
            strContactArray(lngRow, 0) = itm.LastNameAndFirstName
            strContactArray(lngRow, 1) = itm.CompanyName
            strContactArray(lngRow, 2) = itm.BusinessAddress
            strContactArray(lngRow, 3) = itm.FullName
            lngRow = lngRow + 1
         End If
      End If
   Next
   
   Debug.Print lngRow & " filtered contacts"
   lst.List() = strContactArray
   
ErrorHandlerExit:
   Exit Sub

ErrorHandler:
   MsgBox "Error No: " & Err.Number & "; Description: " & Err.Description
   Resume ErrorHandlerExit

End Sub

Private Sub cmdMerge_Click()
'Written by Helen Feddema 5-21-2000
'Last modified 7-10-2000

On Error GoTo ErrorHandler

   Dim intItem As Integer
   Dim intIndex As Integer
   Dim intRow As Integer
   Dim intRows As Integer
   Dim intColumn As Integer
   Dim intColumns As Integer
   Dim strLetterText As String
   
   Set lst = Me![lstContacts]
   strLetterText = Me![txtLetterText]
   
   intColumns = lst.ColumnCount
   intRows = lst.ListCount - 1
   
   For intItem = 1 To intRows
      If lst.Selected(intItem) = True Then
         'Open a new letter based on the Normal template
         'Debug.Print "Creating a letter to : " & Nz(lst.Column(3, intItem))
         Application.Documents.Add
         
         'Paste Outlook data to letter for each selected contact
         With Selection
            .ParagraphFormat.Alignment = wdAlignParagraphRight
            .InsertDateTime DateTimeFormat:="dddd, MMMM dd, yyyy", _
               InsertAsField:=False
            .TypeParagraph
            .ParagraphFormat.Alignment = wdAlignParagraphLeft
            .TypeParagraph
            .TypeParagraph
            .TypeText Text:=Nz(lst.Column(3, intItem))
            .TypeParagraph
            .TypeText Text:=Nz(lst.Column(1, intItem))
            .TypeParagraph
            .TypeText Text:=Nz(lst.Column(2, intItem))
            .TypeParagraph
            .TypeParagraph
            .TypeText "Dear Sir:"
            .TypeParagraph
            .TypeParagraph
            .TypeText strLetterText
            .TypeParagraph
            .TypeParagraph
            .TypeText "Yours sincerely"
            .TypeParagraph
            .TypeParagraph
            .TypeParagraph
            .TypeParagraph
            .TypeText Application.ActiveDocument.BuiltInDocumentProperties(wdPropertyAuthor)
         End With
      End If
      
   Next intItem
   Unload Me
   
ErrorHandlerExit:
   Exit Sub

ErrorHandler:
   MsgBox "Error No: " & Err.Number & "; Description: " & Err.Description
   Resume ErrorHandlerExit

End Sub

Private Sub cmdCancel_Click()
'Written by Helen Feddema 1-15-2000
'Last modified 1-15-2000

On Error GoTo ErrorHandler

   Unload frmOutlookData
   
ErrorHandlerExit:
   Exit Sub

ErrorHandler:
   MsgBox "Error No: " & Err.Number & "; Description: " & Err.Description
   Resume ErrorHandlerExit

End Sub

